/**
   modul demonstruje wzorzec prototypu (wirtualnego konstruktora)
   dla SWO.
 */
#ifndef FIG_HPP
#define FIG_HPP

class Fig {
public:
	int getId() const { return id; }

	virtual void draw() const = 0;
	virtual Fig* clone() const = 0;
	virtual ~Fig() {}
private:
	int id;
};

class Rect : public Fig {
public:
	Rect() {}
	~Rect() {}
	void draw() const;
	Fig* clone() const {
		return new Rect(*this);
	}
};

class RectSpecial : public Rect {
public:
	RectSpecial() {}
	void draw() const;
	Fig* clone() const {
		return new RectSpecial(*this);
	}
};

class Circle : public Fig {
public:
	Circle() {}
	~Circle() {}
	void draw() const;
	Fig* clone() const {
		return new Circle(*this);
	}
};

#endif //FIG_HPP
